          nolist
          pagelen   144

* .hpr'91 - beispiele nach {2} zu den hardwareregistern des ql fr den
* vergleich mit den entprechenden basic-proceduren zum an- und abschalten
* eines microdrive-laufwerks. die steuerung enthlt warteschleifen fr
* hardwaresignale, die zugehrigen taktzahlen gelten fr das standardgert
* mit 68008-processor bei 7,5 MHz takt.

          section   MDV
          data      0


* zum ausprobieren
DRV_TEST  moveq     #1,d1               laufwerk 1
          bsr.s     mdv_run
          bne.s     drv_ret
          bsr.s     mdv_lok             ret in alter betriebsart
          moveq     #0,d0               an basic ohne fehler
drv_ret   rts

* alle laufwerke abschalten - arbeitet nur im supervisor-mode
* bentigt     d5.w processorstatus fr die rckkehr
* gibt zurck  d5.hi.w statuscode dieses aufrufs
*              a0 sv.base     a2 return-adresse
* verdirbt     d1 d2
mdv_lok   swap      d5                  alten status sichern
          move.w    sr,d5
          btst      #13,d5              supervisor-bit
          beq.s     mdv_err             ? user-mode
          move.l    sp,d0
          and.w     #-$8000,d0
          move.l    d0,a0               basis der systemvariablen
          move.l    #$18020,a3
          bsr.s     mdv_off             alles abschalten
          bsr.s     ser_rst             rs232 freigeben
          move.l    (sp)+,a2            return
          swap      d5
          move.w    d5,sr
          jmp       (a2)                rckkehr zum aufruf

* auswahl und start des mdv-laufwerks d1.w
* mit rckkehr im supervisor-mode bei fehlerfreier angabe des laufwerks
*         d0 fehlercode 0 oder -4 err.or
*         d1 d2  verdorben
*                          d5.w processor-status
*         a0 sv.base       a2 return-adresse
*                          a3 $18020 pc.mctrl
mdv_run   tst.w     d1                  prfen der laufwerksnummer
          ble.s     mdv_err             ? untere grenze berschritten
          cmp.w     #8,d1
          bgt.s     mdv_err             ? obere grenze berschritten
          move.l    (sp)+,a2            aufrufadresse
          move.w    sr,d5               processorstatus
          trap      #0                  supervisor mode
*          moveq     #0,d0               korrekt mit mt.inf
*          trap      #1                  basis der systemvariablen nach a0
* in supervisor-mode fhrt die methode aus dem rom schneller zum ziel:
          move.l    sp,d0               ssp
          and.w     #-$8000,d0           fhrt auf die
          move.l    d0,a0                 basis der systemvariablen
          moveq     #16,d0              mdv-betriebsart fr sv.tmode
          bsr.s     ser_dis             ende von rs232-aktionen abwarten
          or.w      #$0700,sr           interrupts sperren
          move.l    #$18020,a3          pc.mctrl steuerregister
          bsr.s     mdv_on              auswahl durchfhren
          moveq     #0,d0               ret ohne fehler
          jmp       (a2)                an den aufruf

mdv_err   moveq     #-4,d0              err.or
          rts

ser_dis   swap      d0                  op-code sichern
ser_pse   subq.w    #1,$a6(a0)          sv.timo weiterzhlen  (    24 takte
          blt.s     set_mde             ? zuende              (    12
          move.w    #$208b,d0                                 (    16
ser_lop   dbra      d0,ser_lop                                (149958
          bra.s     ser_pse             warteschleifen abarbeiten

set_mde   swap      d0                  op-code restauriert
          clr.w     $a6(a0)             wartezeit lschen
          and.b     #%11100111,$a0(a0)  in sv.tmode rs232 ausblenden
          or.b      d0,$a0(a0)          mdv oder netz
          and.b     #$7f,$35(a0)        in sv.pcint sende-interrupt wegmaskieren
set_xit   move.b    $a0(a0),$18002      register pc.tctrl aus sv.tmode laden
          rts

ser_rst   bclr      #4,$a0(a0)          rs232-betriebsart
          or.b      #-128,$35(a0)       sende-interrupt freigeben
          bra.s     set_xit

mdv_off   moveq     #2,d2               abschalt-code
          moveq     #7,d1               alle laufwerke
          bra.s     clk_onof            zum durchschieben

mdv_on    moveq     #3,d2               einschalt-code
          subq.w    #1,d1               anzahl d1 schiebestufen abarbeiten
clk_onof  move.b    d2,(a3)                                   (  12
          moveq     #57,d0                                    (   8
          ror.l     d0,d0               134 pulstakte         ( 114
          bclr      #1,d2
          move.b    d2,(a3)
          moveq     #57,d0
          ror.l     d0,d0               134 pausentakte
          moveq     #2,d2               nur noch taktbit gesetzt
          dbra      d1,clk_onof
          rts

          end
